/// TKS_ScriptModule.h
///
/// (c) 2001-2023 Bastian Spiegel <bs@tkscript.de>
///     - distributed under the terms of the GNU general public license (GPL).
/// 
///
#ifndef __TKS_SCRIPTMODULE_H__
#define __TKS_SCRIPTMODULE_H__

 
class TKS_ScriptModule : public YAC_Object {
public:
	void/*TKS_CachedScript*/*cscript;
   TKS_ScriptObjectID script_id;
   TKS_Namespace *class_nsp;

   sSI last_error_line_idx;  // -1=none, 0..65535

public:
	TKS_ScriptModule  (void);
	~TKS_ScriptModule ();

   sBool setClassNamespace         (YAC_String *_nspName);
	sSI   load                      (YAC_String *_s);
	void  unload                    (void);
   sSI   getLastErrorLineIndex     (void);
	void  findVariable              (YAC_String *_name, YAC_Value *_r);
	void  findTaggedVariableByIndex (sSI _index, YAC_Value *_r);
	void  findFunction              (YAC_String *_name, YAC_Value *_r);
	void  eval                      (void);
};


#endif // __TKS_SCRIPTMODULE_H__
